

#include "pico/stdlib.h"
#include <stdio.h>
#include <math.h>

#include "pico/time.h"
#include "hardware/irq.h"
#include "hardware/structs/adc.h"
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_pwm\include\hardware\pwm.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_adc\include\hardware\adc.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_gpio\include\hardware\gpio.h>
//#include "hardware/adc.h"

#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_sync\include\hardware\sync.h>

#include "hardware/resets.h"
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_spi\include\hardware\spi.h>
#include <C:\abOssmann\PiPico\installation\Pico\pico-sdk\src\rp2_common\hardware_spi\spi.c>

#define PWM_PIN1 2
#define PWM_PIN2 3

#define GPIO4 4
int toggle ;

#define PWMclkDiv 500
#define nDown 1000
#define fSampleADC 500000

uint32_t DDSp ; // DDS phase value
uint32_t DDSd ; // DDS phase delta

int LOsinTab[256] ;
int LOcosTab[256] ;

int demodFil ;
int IIfil ;
int QQfil ;

//-----------------------------------------------------------------------------------
//-----------------------------------------------------------------------------------

#define tftOn 1

// Color definitions
#define ILI9341_BLACK       0x0000      /*   0,   0,   0 */
#define ILI9341_NAVY        0x000F      /*   0,   0, 128 */
#define ILI9341_DARKGREEN   0x03E0      /*   0, 128,   0 */
#define ILI9341_DARKCYAN    0x03EF      /*   0, 128, 128 */
#define ILI9341_MAROON      0x7800      /* 128,   0,   0 */
#define ILI9341_PURPLE      0x780F      /* 128,   0, 128 */
#define ILI9341_OLIVE       0x7BE0      /* 128, 128,   0 */
#define ILI9341_LIGHTGREY   0xC618      /* 192, 192, 192 */
#define ILI9341_DARKGREY    0x7BEF      /* 128, 128, 128 */
#define ILI9341_BLUE        0x001F      /*   0,   0, 255 */
#define ILI9341_GREEN       0x07E0      /*   0, 255,   0 */
#define ILI9341_CYAN        0x07FF      /*   0, 255, 255 */
#define ILI9341_RED         0xF800      /* 255,   0,   0 */
#define ILI9341_MAGENTA     0xF81F      /* 255,   0, 255 */
#define ILI9341_YELLOW      0xFFE0      /* 255, 255,   0 */
#define ILI9341_WHITE       0xFFFF      /* 255, 255, 255 */
#define ILI9341_ORANGE      0xFD20      /* 255, 165,   0 */
#define ILI9341_GREENYELLOW 0xAFE5      /* 173, 255,  47 */
#define ILI9341_PINK        0xF81F

int chrColor = ILI9341_WHITE ; 
int chrBackground = ILI9341_BLACK ; 
int xLast=0 ;
int yLast=0 ;



static void approxSleepUs(int n){
  for(int k=0 ; k<n ; k++){
    for( int kk=0 ; kk<5 ; kk++){
      asm volatile("nop");
      }
    }
  }
  
static void approxSleepMs(int n){
  for(int k=0 ; k<n ; k++){
    for( int kk=0 ; kk<10 ; kk++){
      approxSleepUs(1000) ;
      }
    }
  }

static volatile void approxSleepUsTest(){
  printf("atleastSleepUsTest()\n") ;
  save_and_disable_interrupts() ;
  while(1){
    sio_hw->gpio_set =(1ul << GPIO4) ;  
	  approxSleepUs(1000) ;
    //sleep_ms(1) ;
    sio_hw->gpio_clr =(1ul << GPIO4) ;  
    approxSleepUs(1000) ;
  //  printf(".") ;
  }
} 

#include "tftLib1.c"

//-----------------------------------------------------------------------------------

#define maxsec 50 
#define maxfil 10 

float a0[maxfil]  ;
int secstart[maxfil] ;
int seccnt[maxfil] ;

float w1[maxsec] ;

float w2[maxsec] ;
float a1[maxsec] ;
float a2[maxsec] ;
float b1[maxsec] ;
float b2[maxsec] ;
int filtop=0 ;
int sectop=0  ;

int butter(int nord, float frq){
int i,nsec ; 
float a0x,eps,a,b,s1,s2,t,c1,w,ww,u,v,d ;

if ((nord % 2)!=0){ printf("nord wrong in Tscheby") ; }
filtop++ ;
if( filtop>maxfil){ printf("maxfil error") ; }
nsec=nord / 2 ;
secstart[filtop]=sectop+1 ;
seccnt[filtop]=nsec ;
printf("butterworth filter, no=%d\n",filtop) ;
printf("ord=%d number of sections is %d\n",nord,nsec) ;
a0x=1.0 ;
for( i=nord ; i< 3*nsec ; i++){
  t=(2.0*i+1.0)/(2.0*nord)*M_PI ;
  c1=M_PI*frq ;
  w=sin(c1)/cos(c1) ;
  printf("t=%10.4f  w=%10.4f\n",t,w) ;
  ww=w*w ;
  b=2*w ;
  d=1-b*cos(t)+ww ;
  u=(1-ww)/d ;
  v=b*sin(t)/d ;
  sectop++ ;
  b1[sectop]=-2*u ;
  b2[sectop]=u*u+v*v ;
  printf("b1=%10.4f b2=%10.4f\n",b1[sectop],b2[sectop]) ;
  a1[sectop]=2 ; 
  a2[sectop]=1 ;
  a0x=a0x*(1-2*u+u*u+v*v)/4 ;
  }
printf("a0=%10.4f\n",a0x) ;
a0[filtop]=a0x ;
return filtop ;
}

void tpreset(int filno){ 
  int i ;
  printf("reset filter with no=%d\n",filno) ;
  for (i=secstart[filno] ; i<secstart[filno]+seccnt[filno] ; i++){
  w1[i]=0 ; 
  w2[i]=0 ; 
  printf("clear section %d\n",i) ;
  }
}

float tprun(int filno, float x){
  int i ; 
  float w,w11,w22,y ;
  for(i=secstart[filno] ; i< secstart[filno]+seccnt[filno] ; i++){
    w11=w1[i] ; w22=w2[i] ;
    w=x-b1[i]*w11-b2[i]*w22 ;
    y=w+a1[i]*w11+a2[i]*w22 ;
    w2[i]=w11 ; w1[i]=w ; x=y ;
    }
  return a0[filno]*y ;
  }

//---------------------------------------------------------------

void uart_putc1(char c){
  printf("%c",c) ;
  }

void uart_puts1 (char *s){
  while (*s){   
    uart_putc1(*s);
    s++;
    }
  }

void uart_blank(){
  uart_putc1(' ') ; 
  }

void uart_crlf(){
  uart_putc1(13) ; 
  uart_putc1(10) ;
  }

void uart_cr(){
  uart_putc1(13) ; 
  uart_putc1(10) ;
  }

void decout(int k){
  // uart_putc1(32) ;
  uart_putc1( ((k/1000) % 10)+48 ) ;
  uart_putc1( ((k/100) % 10)+48 ) ;
  uart_putc1( ((k/10) % 10)+48 ) ;
  uart_putc1( (k % 10)+48 ) ;
  uart_putc1(32) ;
  }

void chr_out(uint8_t v){
  uart_putc1(v) ; 
  }

void hex_out(uint8_t v){
  v &=0b00001111 ;
  if (v<=9) { chr_out('0'+v) ; } 
    else { chr_out(v+'A'-10) ; } ;
  }

void byte_out(uint8_t v){
  hex_out(v>>4) ; 
  hex_out(v) ; 
  }

void word_out(uint16_t v){
  byte_out(v>>8) ; 
  byte_out(v) ; 
  }

//------------------------------------------------------------------------------------------------------

int sampleTime=0 ;
int Isum,Qsum ;
static volatile int Ival,Qval ;

#define IntFifoSize 32768
#define IntFifoMask (32768-1)

volatile int IntFifoInPtr ;
volatile int IntFifoOutPtr ;
volatile int16_t IntFifoI[IntFifoSize] ;
volatile int16_t IntFifoQ[IntFifoSize] ;

void IntFifoInit(){
  IntFifoInPtr=0 ;
  IntFifoOutPtr=0 ;
  }

int inputVal ;
int pwm=0 ;

void on_pwm_wrap() {
  gpio_put(GPIO4, 1);
  pwm_clear_irq(pwm_gpio_to_slice_num(PWM_PIN1));
  while(adc_fifo_get_level()){
    DDSp += DDSd ; 
    inputVal=(adc_fifo_get()-2048) ;
    Isum += LOsinTab[DDSp>>24]*inputVal ;
    Qsum += LOcosTab[DDSp>>24]*inputVal ;
    sampleTime++ ;
    if(sampleTime>=nDown){ 
      Ival=Isum/256 ; 
      Qval=Qsum/256 ;
      Isum=0 ;
      Qsum=0 ;
      sampleTime=0 ;
      IntFifoI[IntFifoInPtr]=Ival ;
      IntFifoQ[IntFifoInPtr]=Qval ;
      IntFifoInPtr=(IntFifoInPtr+1) & IntFifoMask ;
      }
    }  
  gpio_put(GPIO4, 0);
  }


//
//-------------------------------------------------------------------------------------
//
//------------------------------------------------------------------------------------------------------
#define scopeXsize 480
#define scopeYsize 100
#define scopeX0 2
#define scopeY0 2
#define scopeColor  ILI9341_WHITE 
#define scopeBackground  ILI9341_DARKGREEN 

int scopeX ;
int scopeYi[scopeXsize] ;

void scopeInit(){
  tftRectf(scopeX0, scopeY0, scopeXsize, scopeYsize, scopeBackground ) ;
  scopeX=0 ;
  for(int k=0 ; k<scopeXsize ; k++){
    scopeYi[k]=0 ;
    }
  }

void doScope(int y){
  static int lastY=0 ;
  if(y<0){ y=0 ; }
  if(y>=scopeYsize){ y=scopeYsize-1 ; }
  y += scopeY0 ;
  if(scopeX>0){
    tftLine(scopeX0+scopeX-1,lastY,scopeX0+scopeX,scopeYi[scopeX],scopeBackground) ;
    tftLine(scopeX0+scopeX-1,scopeYi[scopeX-1],scopeX0+scopeX,y,scopeColor) ;
    }
  lastY=scopeYi[scopeX] ;
  scopeYi[scopeX]=y ;
  scopeX++ ;
  if(scopeX>=scopeXsize){ scopeX=0 ; }
  }

//------------------------------------------------------------------------------------------------------

//
//-------------------------------------------------------------------------------------
//

#define LFcode 10 
#define CRcode 13 
#define UU     'y' 
#define Ltrs 130
#define Figs 131

//
//-------------------------------------------------------------------------------------
//


//
// software uart for BAUDOT code
//


// 'x' = who-is-there
// 'y' = unused


char BaudotTable []={
  'o'    , 'E', LFcode , 'A', ' ', 'S', 'I', 'U',
  CRcode , 'D', 'R'    , 'J', 'N', 'F', 'C', 'K',
  'T'    , 'Z', 'L'    , 'W', 'H', 'Y', 'P', 'Q',
  'O'    , 'B', 'G'    , Ltrs,'M', 'X', 'V', Figs, 
  'o'    , '3', LFcode , '1', ' ', '"', '8', '7',
  CRcode , 'x', '4'    , 'b', ',',  UU, ':', '(',
  '5'    , '+', ')'    , '2',  UU, '6', '0', '1',
  '9'    , '?', '&'    , Ltrs, '.', '/', '=', Figs } ;

int uartTimer ;
int uartShiftReg ;
int uartBitCount ;
int baudotShift ;

void uartPutc3(int c){
  printf("%c",(char)c) ;
  termPutc(c) ;
  }
  
void BaudotPrint(int baudotChar){
   int AsciiChar ;
   AsciiChar= BaudotTable [ baudotChar+(baudotShift<<5) ] ;
   if ( AsciiChar==Figs) { 
     baudotShift=0 ; 
   AsciiChar=0 ; 
   }
    else if ( AsciiChar==Ltrs ) {
   baudotShift=1 ; 
   AsciiChar=0 ; 
   }
   if (AsciiChar!=0) { 
     // display only printable characters
     uartPutc3(AsciiChar) ; 
   }
  }

void softUartInit147(){
  uartShiftReg=0 ;
  uartTimer=0 ;
  baudotShift=0 ;
  }

int uartStart ; // only used for display purposes

// 50bd at 500 samplerate
#define uartFullTime 10 
#define uartHalfTime 6 

void checkForStartBit147(int input){
  if ( input != 0) { 
    uartTimer=uartHalfTime ;
    uartBitCount=0 ; 
    uartShiftReg=0 ; 
    uartStart=1 ; 
    }
  }

void uartSample147(int input){
  if (uartTimer==0) {
     checkForStartBit147(input) ;
    }
   else { 
    uartTimer++ ;
    }
  if (uartTimer>uartFullTime) {
    // a full bit time has elapsed again
    uartTimer -= uartFullTime ;
    // shift input into shiftregister
    if ( input == 0) { 
      uartShiftReg=uartShiftReg+(1 << uartBitCount) ; 
      }
    // count bits
    uartBitCount++ ;
    if (uartBitCount==6) {
    // we have enough bits
      uartShiftReg=uartShiftReg >>1  ; // eliminate stop-bit
      BaudotPrint(uartShiftReg) ;
      }
    if (uartBitCount>6) {
      // too many bits, restart 
      uartBitCount=0 ; 
      uartTimer=0 ; 
      }
    }
  }

//----------------------------------------------------------------------------------------  

int Qout ;
int Iout ;
int EstimatedPhase ;
int OldPhase ;
int diff ;
int frq ;

int SchmittTrigger(float v){
  float threshold=0.2 ;
  int RXbit1=0 ;
  if(v> threshold){ RXbit1=0 ; }
  if(v<-threshold){ RXbit1=1 ; }
  return RXbit1 ;
  }

int extendedPhase=0 ;
int  RXbit=0 ;

void doIQsample(){
  int Isample=IntFifoI[IntFifoOutPtr] ;
  int Qsample=IntFifoQ[IntFifoOutPtr] ;
  IntFifoOutPtr=(IntFifoOutPtr+1) & IntFifoMask ;
  Qout = tprun(QQfil,Qsample)/250 ; 
  Iout = tprun(IIfil,Isample)/250 ; 
  EstimatedPhase=((int)(128/M_PI* atan2(Qout,Iout))) & 0xFF ;
  diff=EstimatedPhase-OldPhase ;
  OldPhase=EstimatedPhase ;
  if(diff>128){ diff -= 256 ; }
  if(diff<-128){ diff +=256 ; }

  extendedPhase += diff ;
  if(extendedPhase>512){ extendedPhase -= 1024 ; }
  if(extendedPhase<-512){ extendedPhase +=1024 ; }
  pwm_set_gpio_level(PWM_PIN1, 250+extendedPhase/3 );

  frq=-10*tprun(demodFil,diff) ;
  RXbit=SchmittTrigger(frq) ;
  uartSample147(RXbit) ;
  pwm_set_gpio_level(PWM_PIN2, 125+50*RXbit);

  int yy=50+frq/10 ;
  doScope(yy) ;
  // doScope(EstimatedPhase) ;
 // pwm_set_gpio_level(PWM_PIN1, 125+5*CICfifoIout );
 // pwm_set_gpio_level(PWM_PIN2, 125+5*CICfifoQout );

  //pwm_set_gpio_level(PWM_PIN1, 125+2*diff );
 
  pwm_set_gpio_level(PWM_PIN2, 125+50*RXbit);
  }

double fPWM ;

void PWMsetup(){    
  gpio_set_function(PWM_PIN1, GPIO_FUNC_PWM);
  gpio_set_function(PWM_PIN2, GPIO_FUNC_PWM);
  // Figure out which slice we just connected to the pin
  uint slice_num1 = pwm_gpio_to_slice_num(PWM_PIN1);
  uint slice_num2 = pwm_gpio_to_slice_num(PWM_PIN2);
  // Mask our slice's IRQ output into the PWM block's single interrupt line,
  // and register our interrupt handler
  pwm_clear_irq(slice_num1);
  pwm_set_irq_enabled(slice_num1, true);
  irq_set_exclusive_handler(PWM_IRQ_WRAP, on_pwm_wrap);
  irq_set_enabled(PWM_IRQ_WRAP, true);
  // Get some sensible defaults for the slice configuration. 
  pwm_config config1 = pwm_get_default_config();
  pwm_config config2 = pwm_get_default_config();
  // Set divider, reduces counter clock to sysclock/this value
  pwm_config_set_clkdiv(&config1, 1.f);
  pwm_config_set_clkdiv(&config2, 1.f);
  // Load the configuration into our PWM slice, and set it running.
  pwm_init(slice_num1, &config1, true);
  pwm_init(slice_num2, &config2, true);
  
 
  pwm_set_wrap(slice_num1,(PWMclkDiv-1) );
  pwm_set_wrap(slice_num2,(PWMclkDiv-1) );
  fPWM=125e6/PWMclkDiv/1.0 ;
  printf("\n\n") ;
  printf("fPWM       =%15.5f 1/s\n",fPWM) ;
  printf("fSampleADC =%15.5f 1/s\n",fSampleADC) ;
  printf("fSample2   =%15.5f 1/s\n",fSampleADC/nDown) ;

  printf("PWM_PIN1=%d\n",PWM_PIN1) ;
  printf("slice_num1=%d\n",slice_num1) ;
  printf("config1=%d\n",config1) ;
  printf("\n") ;
  printf("PWM_PIN2=%d\n",PWM_PIN2) ;
  printf("slice_num2=%d\n",slice_num2) ;
  printf("config2=%d\n",config2) ;
  }

int kDown ;

void abort(){
  printf("abort..\n") ;
  printf("\n") ;
  while(1){} ;
  }


void adcInit(void) {
  // ADC is in an unknown state. We should start by resetting it
  reset_block(RESETS_RESET_ADC_BITS);
  unreset_block_wait(RESETS_RESET_ADC_BITS);
  // Now turn it back on. Staging of clock etc is handled internally
  adc_hw->cs = ADC_CS_EN_BITS;
  // Internal staging completes in a few cycles, but poll to be sure
  while (!(adc_hw->cs & ADC_CS_READY_BITS)) {
    tight_loop_contents();
    }

  // Select ADC input 2 (GPIO28)
  adc_gpio_init(28);
  adc_select_input(2);

  adc_fifo_setup(true, false, 0, false, false);
  adc_run(true);

  // stop adc
  //adc_run(false);
  //adc_fifo_drain();
  }


int main() {
  stdio_init_all();
  gpio_init(GPIO4);
  gpio_set_dir(GPIO4, GPIO_OUT);

  approxSleepMs(200);
  printf("//\n") ;
  printf("//\n") ;
  printf("Hello DWDdecode147p3ConsoleToUartV01 !\n") ;

  tftSetup() ;
  cursorX=10 ;
  cursorY=300 ;
  tftPrint("Hello TFT!") ;
  scopeInit() ;

  IntFifoInit() ;
  PWMsetup() ;
  softUartInit147() ;

  int fil1=butter(6,0.2) ;
  tpreset(fil1) ;
  //abort() ;
  demodFil=butter(2,40.0/800.0) ;
  IIfil=butter(2,50.0/800.0) ;
  QQfil=butter(2,50.0/800.0) ;

 
  
  toggle=0 ;
   
  double DDSfrq=147300.0-0.6 ;
  adcInit();
  

  for(int k=0 ; k<256 ; k++){
    double phi=2*M_PI*k/256.0 ;
    LOcosTab[k]=100*cos(phi) ;
    LOsinTab[k]=100*sin(phi) ;
    }

  DDSp =0 ;
  DDSd=(int)( 4294967296.0*DDSfrq/fSampleADC) ;
 
  termInit() ;
  //abort() ;

  kDown=0 ;
  while (1){
    kDown++ ;
    if(kDown=250000) {
      //printf("d=%10d\n",diff) ;
     // printf("f=%10d\n",frq) ;
      kDown=0 ;
      }
    if( IntFifoInPtr != IntFifoOutPtr ){
    //  gpio_put(GPIO4, 1);
	    doIQsample() ;
    //  gpio_put(GPIO4, 0);
        }
    }
  }

